Last Comment Bug 65133 - implement CSS3 selectors
: implement CSS3 selectors
Status: RESOLVED FIXED
: css3, meta
Product: Core
Classification: Components
Component: CSS Parsing and Computation (show other bugs)
: Trunk
: All All
: P4 enhancement with 47 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
http://www.w3.org/TR/css3-selectors/
Depends on: 176170 221981 46916 71100 71647 75186 75374 75375 84400 120834 128585 135141 188734 237568
Blocks:
  Show dependency treegraph
 
Reported: 2001-01-11 15:38 PST by Marc Attinasi
Modified: 2010-03-05 09:21 PST (History)
61 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Marc Attinasi 2001-01-11 15:38:53 PST
This is a tracking bug for CSS3 selector implementation in Mozilla.

Initially, there is widespread desire for the :not() selector, please list
others desired and what we need them for in this bug.

Personally, I think that the :nth-child(an+b) and :nth-of-type(an+b) and their
related pseudos are extremely compelling and useful (table rows alternating
colors is the obvious example).
Comment 1 Marc Attinasi 2001-01-11 15:40:21 PST
bug 57686 is reportedly blocked by lack of the :not() pseudo-class
Comment 2 Hixie (not reading bugmail) 2001-02-12 16:48:52 PST
Netscape's standard compliance QA team reorganised itself once again, so taking 
remaining non-tables style bugs. Sorry about the spam. I tried to get this done 
directly at the database level, but apparently that is "not easy because of the 
shadow db", "plus it screws up the audit trail", so no can do...
Comment 3 Marc Attinasi 2001-02-23 13:49:24 PST
Adding bug 68206 whcih requests the CSS3 ::selection pseudo-element for
skinability purposes.
Comment 4 Charles Manske 2001-02-27 13:51:53 PST
Can anyone estimate when this work might be done? It would be appreciated for
mozilla 1.0 / NS 6.5
Comment 5 Marc Attinasi 2001-03-01 13:38:17 PST
This is a tracking bug. Since you have bug 57686 which needs the :not selector,
I'm thinking that we should spin off a separate bug requesting that selector
specifically, and mark your bug dependent on that one instead of this one. It
could take *years* to do all of he CSS3 selectors...

I'm also reassigning this to Daniel since he will be taking over the new
selector implementations in all likelihood (if anyone disagrees, please make the
proper reassignments).
Comment 6 Daniel Glazman (:glazou) 2001-03-06 16:22:32 PST
Adding dependency to ParseSelector() current cleanup.
Comment 7 Daniel Glazman (:glazou) 2001-03-11 17:36:38 PST
trk: Adding dependency to bug 71647 for the :not() pseudo-class
Comment 8 rubydoo123 2001-03-12 10:18:40 PST
setting to moz1.0 for now
Comment 9 Hixie (not reading bugmail) 2001-03-13 15:50:10 PST
Marking "meta" since this is a tracking bug. Let's file new bugs each time we
want to track the implementation of a particular part of CSS3 selectors, and
mark them as dependencies.
Comment 10 Daniel Glazman (:glazou) 2001-03-21 03:43:27 PST
status of css3 selectors that did not already exist in css 2 :

   IMPLEMENTED :

            substring matching attribute selectors
            negation pseudo-class
            root pseudo-class
            namespaces in type and attribute selectors (though buggy ;
                                                        see 72302)

   RESERVED in nsCSSAtomList.h (by peter linss years ago !!!)
   AND PARSED BUT NOT IMPLEMENTED

            :checked, :enabled, :disabled, :selection


Comment 11 Asa Dotzler [:asa] 2001-12-03 11:17:27 PST
Bugs targeted at mozilla1.0 without the mozilla1.0 keyword moved to mozilla1.0.1 
(you can query for this string to delete spam or retrieve the list of bugs I've 
moved)
Comment 12 David Denis 2001-12-10 11:50:57 PST
CSS3 Selectors are now a candidate recommendation:
http://www.w3.org/TR/2001/CR-css3-selectors-20011113/
Comment 13 Kai Lahmann (is there, where MNG is) 2002-06-28 15:08:49 PDT
we don't have bugs for:
:target
:lang() [CSS2, but still missing]
:first-of-type / :last-of-type
:only-child
:only-of-type
~ (indirect adjacent)
:contains()

except this the CSS3 Selector-test shows a problem with *:not(:hover) [it's
ignored] and the :enabled and :disabled tests doesn't load. Also some problems
with namespaces I can't determine any further..
Comment 14 Anne (:annevk) 2003-09-27 11:32:37 PDT
Added the bug for :target (bug 188734). 
bug 75186 (:empty) is actually not fixed at all. There are other bugs where the
issues are reported: bug 157395, bug 98997 and bug 188953.
Comment 15 francis storr 2003-10-18 05:09:54 PDT
:contains would be very nice to have.  One example is for table formatting of
empty cells, user you add background colour or even content to show it was
purposely empty, without the need for additional classes.
Comment 16 Anne (:annevk) 2003-10-18 05:22:35 PDT
You can do this with :empty, which is already supported by Mozilla. bug 221981
is for contains(). Please don't comment on bugs without additional information.
It has been told to me that this is only slowing down the developers ;).
Comment 17 Adam Guthrie 2005-10-04 13:04:57 PDT
*** Bug 311039 has been marked as a duplicate of this bug. ***
Comment 18 The 8472 2007-05-12 04:30:41 PDT
Here is a nice test-suite for CSS3 selectors: http://www.css3.info/selectors-test/
Comment 19 Laurent Jouanneau 2007-06-26 08:23:38 PDT
Opera 9.5 and KHTML 3.5.6 have a full 
Comment 20 Laurent Jouanneau 2007-06-26 08:25:06 PDT
oups, sorry for spam. 

Opera 9.5 and KHTML 3.5.6 have a full implementation of css3 selectors.
Comment 21 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2007-06-26 09:06:32 PDT
KHTML 3.5.6 fails a bunch of the tests in http://www.w3.org/Style/CSS/Test/CSS3/Selectors/current/xhtml/index.html  (I've been clicking on a bunch randomly (probably about 20% of them), and already noticed 57, 97b, 98b, 103, 115b, 150, 171, 172a, 172b, d5, and d5b.)  And that test suite isn't complete (although probably more complete than the one in comment 18, which I'm guessing is what led to that claim).
Comment 22 Ryan VanderMeulen [:RyanVM] 2009-02-12 15:13:04 PST
(In reply to comment #18)
> Here is a nice test-suite for CSS3 selectors:
> http://www.css3.info/selectors-test/

For the record, Firefox 3.1b2 passes this suite 100%. jresiq has another test suite available at the link below, which 3.1b2 is currently 99.3% passing.
http://ejohn.org/apps/selectortest/
Comment 23 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2009-02-12 16:47:16 PST
The selectors draft is going back to last call shortly with ::selection removed, so we're done here.

Note You need to log in before you can comment on or make changes to this bug.